Index: code/branches/objecthierarchy/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/objecthierarchy/src/orxonox/CMakeLists.txt	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/CMakeLists.txt	(revision 2019)
@@ -43,4 +43,7 @@
   tools/WindowEventListener.cc
 
+  LevelManager.cc
+
+  objects/Scene.cc
   objects/worldentities/WorldEntity.cc
   objects/worldentities/PositionableEntity.cc
@@ -63,4 +66,6 @@
   objects/DistanceTrigger.cc
 
+  objects/worldentities/SpawnPoint.cc
+
   objects/worldentities/pawns/Spectator.cc
 
@@ -71,4 +76,5 @@
   objects/infos/Level.cc
   objects/infos/PlayerInfo.cc
+  objects/infos/HumanPlayer.cc
 
   objects/gametypes/Gametype.cc
Index: code/branches/objecthierarchy/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/LevelManager.cc	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/LevelManager.cc	(revision 2019)
@@ -0,0 +1,133 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+
+#include "LevelManager.h"
+
+#include "core/CoreIncludes.h"
+
+#include "objects/infos/Level.h"
+#include "objects/infos/HumanPlayer.h"
+
+namespace orxonox
+{
+    LevelManager::LevelManager()
+    {
+        RegisterRootObject(LevelManager);
+
+        this->getConnectedClients();
+    }
+
+    LevelManager& LevelManager::getInstance()
+    {
+        static LevelManager instance;
+        return instance;
+    }
+
+    void LevelManager::requestActivity(Level* level)
+    {
+        this->levels_s.push_back(level);
+        if (this->levels_s.size() == 1)
+            this->activateNextLevel();
+    }
+
+    void LevelManager::releaseActivity(Level* level)
+    {
+        if (this->levels_s.size() > 0)
+        {
+            if (this->levels_s.front() == level)
+            {
+                level->setActive(false);
+                this->levels_s.pop_front();
+                this->activateNextLevel();
+            }
+            else
+            {
+                for (std::list<Level*>::iterator it = this->levels_s.begin(); it != this->levels_s.end(); ++it)
+                    if ((*it) == level)
+                        this->levels_s.erase(it);
+            }
+        }
+    }
+
+    Level* LevelManager::getActiveLevel()
+    {
+        if (this->levels_s.size() > 0)
+            return this->levels_s.front();
+        else
+            return 0;
+    }
+
+    void LevelManager::activateNextLevel()
+    {
+        if (this->levels_s.size() > 0)
+        {
+            this->levels_s.front()->setActive(true);
+            for (std::map<unsigned int, PlayerInfo*>::iterator it = this->clients_.begin(); it != this->clients_.end(); ++it)
+                this->levels_s.front()->playerEntered(it->second);
+        }
+    }
+
+
+    void LevelManager::clientConnected(unsigned int clientID)
+    {
+        COUT(0) << "client connected" << std::endl;
+
+        // create new HumanPlayer instance
+        HumanPlayer* player = new HumanPlayer(0);
+        player->setClientID(clientID);
+
+        // add to clients-map
+        assert(!this->clients_[clientID]);
+        this->clients_[clientID] = player;
+    }
+
+    void LevelManager::clientDisconnected(unsigned int clientID)
+    {
+        COUT(0) << "client disconnected" << std::endl;
+
+        // remove from clients-map
+        PlayerInfo* player = this->clients_[clientID];
+        this->clients_.erase(clientID);
+
+        // delete PlayerInfo instance
+        if (player)
+            delete player;
+    }
+
+
+    PlayerInfo* LevelManager::getClient(unsigned int clientID) const
+    {
+        std::map<unsigned int, PlayerInfo*>::const_iterator it = this->clients_.find(clientID);
+        if (it != this->clients_.end())
+            return it->second;
+        else
+            return 0;
+    }
+}
Index: code/branches/objecthierarchy/src/orxonox/LevelManager.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/LevelManager.h	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/LevelManager.h	(revision 2019)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LevelManager_H__
+#define _LevelManager_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <list>
+#include <map>
+
+#include "network/ClientConnectionListener.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport LevelManager : public network::ClientConnectionListener
+    {
+        public:
+            static LevelManager& getInstance();
+
+            void requestActivity(Level* level);
+            void releaseActivity(Level* level);
+            Level* getActiveLevel();
+
+            PlayerInfo* getClient(unsigned int clientID) const;
+            inline const std::map<unsigned int, PlayerInfo*>& getClients() const
+                { return this->clients_; }
+
+        private:
+            LevelManager();
+            virtual ~LevelManager() {}
+
+            void clientConnected(unsigned int clientID);
+            void clientDisconnected(unsigned int clientID);
+
+            void activateNextLevel();
+
+            std::list<Level*> levels_s;
+            std::map<unsigned int, PlayerInfo*> clients_;
+    };
+}
+
+#endif /* _LevelManager_H__ */
Index: code/branches/objecthierarchy/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/OrxonoxPrereqs.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/OrxonoxPrereqs.h	(revision 2019)
@@ -80,13 +80,26 @@
     class RadarListener;
 
+    class LevelManager;
+
     // objects
+    class Scene;
+
     class WorldEntity;
     class PositionableEntity;
     class MovableEntity;
     class ControllableEntity;
+    class Sublevel;
 
     class Model;
+    class Billboard;
+    class Light;
+    class DirectionalLight;
+
+    class Camera;
+    class SpawnPoint;
 
     class Spectator;
+    class Pawn;
+    class SpaceShip;
 
     class Controller;
@@ -94,5 +107,4 @@
 
     class Backlight;
-    class Camera;
     class ParticleSpawner;
 
@@ -100,6 +112,9 @@
     class Level;
     class PlayerInfo;
+    class HumanPlayer;
 
     class Gametype;
+
+    class Scores;
 
     // tools
Index: code/branches/objecthierarchy/src/orxonox/objects/Camera.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Camera.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/Camera.cc	(revision 2019)
@@ -32,4 +32,5 @@
 
 #include <string>
+#include <cassert>
 
 #include <OgreSceneManager.h>
@@ -41,73 +42,91 @@
 #include "util/SubString.h"
 #include "util/Math.h"
+#include "util/String.h"
 #include "util/Debug.h"
 #include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
 #include "GraphicsEngine.h"
+#include "objects/Scene.h"
 
 namespace orxonox
 {
-  CreateUnloadableFactory(Camera);
+    CreateFactory(Camera);
 
-  Camera::Camera()
-  {
-    RegisterObject(Camera);
+    Camera::Camera(BaseObject* creator) : PositionableEntity(creator)
+    {
+        RegisterObject(Camera);
 
-    this->bHasFocus_ = false;
-    this->bDrag_ = false;
-    this->cameraNode_ = GraphicsEngine::getInstance().getLevelSceneManager()->getRootSceneNode()->createChildSceneNode();
-    this->setObjectMode(0x0);
-  }
+        assert(this->getScene());
+        assert(this->getScene()->getSceneManager());
 
-  Camera::~Camera()
-  {
-    if (this->isInitialized())
+        this->camera_ = this->getScene()->getSceneManager()->createCamera(getUniqueNumberString());
+        this->getNode()->attachObject(this->camera_);
+
+        this->bHasFocus_ = false;
+        this->bDrag_ = false;
+        this->nearClipDistance_ = 1;
+
+        this->setObjectMode(0x0);
+
+        this->setConfigValues();
+        this->configvaluecallback_changedNearClipDistance();
+
+        this->requestFocus(); // ! HACK ! REMOVE THIS !
+    }
+
+    Camera::~Camera()
     {
-      CameraHandler::getInstance()->releaseFocus(this);
-      GraphicsEngine::getInstance().getLevelSceneManager()->getRootSceneNode()->removeAndDestroyChild(this->cameraNode_->getName());
+        if (this->isInitialized())
+        {
+            this->releaseFocus();
+        }
     }
-  }
 
-  void Camera::tick(float dt)
-  {
-      // this stuff here may need some adjustments
-      float coeff = (this->bDrag_) ? min(1.0f, 15.0f * dt) : (1.0f);
+    void Camera::setConfigValues()
+    {
+        SetConfigValue(nearClipDistance_, 1.0f).callback(this, &Camera::configvaluecallback_changedNearClipDistance);
+    }
 
-      Vector3 offset = this->getNode()->getWorldPosition() - this->cameraNode_->getWorldPosition();
-      this->cameraNode_->translate(coeff * offset);
+    void Camera::configvaluecallback_changedNearClipDistance()
+    {
+        this->camera_->setNearClipDistance(this->nearClipDistance_);
+    }
 
-      this->cameraNode_->setOrientation(Quaternion::Slerp(coeff, this->cameraNode_->getWorldOrientation(), this->getWorldOrientation(), false));
-  }
+    void Camera::tick(float dt)
+    {
+/*
+        // this stuff here may need some adjustments
+        float coeff = (this->bDrag_) ? min(1.0f, 15.0f * dt) : (1.0f);
 
-  /**
-    don't move anything before here! here the Ogre camera is set to values of this camera
-    always call update after changes
-  */
-  void Camera::update()
-  {
-      this->cameraNode_->setPosition(this->getWorldPosition());
-      this->cameraNode_->setOrientation(this->getWorldOrientation());
-  }
+        Vector3 offset = this->getNode()->getWorldPosition() - this->cameraNode_->getWorldPosition();
+        this->cameraNode_->translate(coeff * offset);
 
-  /**
-    what to do when camera loses focus (do not request focus in this function!!)
-    this is called by the CameraHandler singleton class to notify the camera
-  */
-  void Camera::removeFocus()
-  {
-    this->bHasFocus_ = false;
-    this->cameraNode_->detachObject(this->cam_);
-  }
+        this->cameraNode_->setOrientation(Quaternion::Slerp(coeff, this->cameraNode_->getWorldOrientation(), this->getWorldOrientation(), false));
+*/
+    }
 
-  void Camera::setFocus(Ogre::Camera* ogreCam)
-  {
-    this->bHasFocus_ = true;
-    this->cam_ = ogreCam;
-    this->cam_->setOrientation(this->cameraNode_->getWorldOrientation());
-    this->cameraNode_->attachObject(this->cam_);
-  }
+    void Camera::requestFocus()
+    {
+        CameraHandler::getInstance().requestFocus(this);
+    }
 
-  void Camera::requestFocus()
-  {
-    CameraHandler::getInstance()->requestFocus(this);
-  }
+    void Camera::releaseFocus()
+    {
+        CameraHandler::getInstance().releaseFocus(this);
+    }
+
+    /**
+        what to do when camera loses focus (do not request focus in this function!!)
+        this is called by the CameraHandler singleton class to notify the camera
+    */
+    void Camera::removeFocus()
+    {
+        this->bHasFocus_ = false;
+    }
+
+    void Camera::setFocus(Ogre::Viewport* viewport)
+    {
+        this->bHasFocus_ = true;
+        viewport->setCamera(this->camera_);
+    }
 }
Index: code/branches/objecthierarchy/src/orxonox/objects/Camera.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Camera.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/Camera.h	(revision 2019)
@@ -42,31 +42,33 @@
     class _OrxonoxExport Camera : public PositionableEntity, public Tickable
     {
-      friend class CameraHandler;
+        friend class CameraHandler;
 
-      public:
-        Camera();
-        virtual ~Camera();
+        public:
+            Camera(BaseObject* creator);
+            virtual ~Camera();
 
-        virtual void tick(float dt);
-        void update();
+            void setConfigValues();
+            virtual void tick(float dt);
 
-        void requestFocus();
-        inline bool hasFocus()
-            { return this->bHasFocus_; }
+            void requestFocus();
+            void releaseFocus();
 
-        inline void setDrag(bool bDrag)
-            { this->bDrag_ = bDrag; }
-        inline bool getDrag() const
-            { return this->bDrag_; }
+            inline bool hasFocus()
+                { return this->bHasFocus_; }
 
-      private:
-        void removeFocus();
-        void setFocus(Ogre::Camera* ogreCam);
+            inline void setDrag(bool bDrag)
+                { this->bDrag_ = bDrag; }
+            inline bool getDrag() const
+                { return this->bDrag_; }
 
-        Ogre::Camera* cam_;
-        Ogre::SceneNode* cameraNode_;
-        Ogre::Vector3 oldPos;
-        bool bHasFocus_;
-        bool bDrag_;
+        private:
+            void removeFocus();
+            void setFocus(Ogre::Viewport* viewport);
+            void configvaluecallback_changedNearClipDistance();
+
+            Ogre::Camera*   camera_;
+            float           nearClipDistance_;
+            bool            bHasFocus_;
+            bool            bDrag_;
     };
 }
Index: code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.cc	(revision 2019)
@@ -33,4 +33,5 @@
 
 #include "core/ObjectList.h"
+#include "core/Core.h"
 #include "Camera.h"
 #include "GraphicsEngine.h"
@@ -38,60 +39,58 @@
 #include <OgreCamera.h>
 
-namespace orxonox {
+namespace orxonox
+{
+    CameraHandler::CameraHandler()
+    {
+//        GraphicsEngine::getInstance().getViewport()->setCamera(this->cam_);
+    }
 
-  CameraHandler* CameraHandler::singletonRef = NULL;
+    CameraHandler& CameraHandler::getInstance()
+    {
+        static CameraHandler instance;
+        return instance;
+    }
 
-  CameraHandler::CameraHandler()
-  {
-    this->cam_ = GraphicsEngine::getInstance().getLevelSceneManager()->createCamera("Cam");
-    GraphicsEngine::getInstance().getViewport()->setCamera(this->cam_);
-    this->cam_->setNearClipDistance(1);
-    //GraphicsEngine::getInstance().getRenderWindow()->addViewport(this->cam_, 2, 0.4, 0.4, 0.2, 0.2);
-    /*this->activeCamera_ = *ObjectList<Camera>::begin();
-    this->activeCamera_->cam_ = this->cam_;*/
-  }
+    Camera* CameraHandler::getActiveCamera() const
+    {
+        if (this->cameraList_.size() > 0)
+            return this->cameraList_.front();
+        else
+            return 0;
+    }
 
-  void CameraHandler::requestFocus(Camera* requestCam)
-  {
-    // notify old camera (if it exists)
-    if(focusList_.size() > 0)
-      focusList_.back()->removeFocus();
-    // add to list
-    focusList_.push_back(requestCam);
-    // set focus to new camera and update (if necessary)
-    if(!requestCam->hasFocus()) {
-      requestCam->setFocus(this->cam_);
-      requestCam->update();
+    void CameraHandler::requestFocus(Camera* camera)
+    {
+        if (!Core::showsGraphics())
+            return;
+
+        // notify old camera (if it exists)
+        if (this->cameraList_.size() > 0)
+            this->cameraList_.front()->removeFocus();
+
+        // add to list
+        this->cameraList_.push_front(camera);
+        camera->setFocus(GraphicsEngine::getInstance().getViewport());
     }
-    // delete dublicates
-    focusList_.unique();
-  }
 
-  void CameraHandler::releaseFocus(Camera* cam)
-  {
-    // notify the cam of releasing the focus
-    if(cam->hasFocus())
-      cam->removeFocus();
-    // delete camera from list
-    focusList_.remove(cam);
-    // set new focus if necessary
-    if(focusList_.size() > 0 && !(focusList_.back()->hasFocus()))
-      focusList_.back()->setFocus(this->cam_);
-  }
-/*
-  void CameraHandler::changeActiveCamera(Camera* setCam)
-  {
-    cam_->getParentSceneNode()->detachObject(cam_);
-    //setCam->attachCamera(cam_);
-    activeCamera_ = setCam;
-  }
-*/
-/*  bool isInVector(Camera* cam)
-  {
-    for(std::vector<Camera*>::iterator it = cams_.begin(); it != cams_.end(); it++)
+    void CameraHandler::releaseFocus(Camera* camera)
     {
-      if (*it == cam) return true;
+        if (!Core::showsGraphics())
+            return;
+
+        // notify the cam of releasing the focus
+        if (this->cameraList_.front() == camera)
+        {
+            camera->removeFocus();
+            this->cameraList_.pop_front();
+
+            // set new focus if necessary
+            if (cameraList_.size() > 0)
+                cameraList_.front()->setFocus(GraphicsEngine::getInstance().getViewport());
+        }
+        else
+        {
+            this->cameraList_.remove(camera);
+        }
     }
-    return false;
-  }*/
 }
Index: code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/CameraHandler.h	(revision 2019)
@@ -36,9 +36,8 @@
 #define _Camera_Handler_H__
 
+#include "OrxonoxPrereqs.h"
+
 #include <list>
-
 #include <OgreCamera.h>
-
-#include "OrxonoxPrereqs.h"
 
 #include "core/BaseObject.h"
@@ -46,27 +45,20 @@
 namespace orxonox
 {
-  class _OrxonoxExport CameraHandler
-  {
+    class _OrxonoxExport CameraHandler
+    {
+        public:
+            static CameraHandler& getInstance();
 
-    public:
-      inline static CameraHandler* getInstance() { if (!CameraHandler::singletonRef) CameraHandler::singletonRef = new CameraHandler(); return CameraHandler::singletonRef; }
-      inline ~CameraHandler() { CameraHandler::singletonRef = NULL; }
-      inline Camera* getActiveCamera() { return this->focusList_.back(); }
-      /*void registerCamera(Camera* newCam);
-      void changeActiveCamera(Camera* setCam);*/
-      void requestFocus(Camera* requestCam);
-      void releaseFocus(Camera* cam);
+            Camera* getActiveCamera() const;
 
-    private:
-      CameraHandler();
-      //bool isInVector(Camera* cam);
+            void requestFocus(Camera* camera);
+            void releaseFocus(Camera* camera);
 
-    private:
-      static CameraHandler* singletonRef;
-      Ogre::Camera* cam_;
-      std::list<Camera*> focusList_;
-      //std::vector<Camera*> cams_;
+        private:
+            CameraHandler();
+            ~CameraHandler() {}
 
-  };
+            std::list<Camera*> cameraList_;
+    };
 }
 
Index: code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.cc	(revision 2019)
@@ -37,5 +37,5 @@
   CreateFactory(DistanceTrigger);
 
-  DistanceTrigger::DistanceTrigger()
+  DistanceTrigger::DistanceTrigger(BaseObject* creator) : Trigger(creator)
   {
     RegisterObject(DistanceTrigger);
Index: code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/DistanceTrigger.h	(revision 2019)
@@ -44,5 +44,5 @@
   {
     public:
-      DistanceTrigger();
+      DistanceTrigger(BaseObject* creator);
       ~DistanceTrigger();
       void addTarget(Ogre::Node* targetNode);
Index: code/branches/objecthierarchy/src/orxonox/objects/ParticleSpawner.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/ParticleSpawner.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/ParticleSpawner.cc	(revision 2019)
@@ -80,5 +80,5 @@
         this->setPosition(this->getNode()->getParent()->getPosition());
         this->getNode()->getParent()->removeChild(this->getNode());
-        GraphicsEngine::getInstance().getLevelSceneManager()->getRootSceneNode()->addChild(this->getNode());
+        this->detachFromParent();
         if (this->particle_)
             this->particle_->setEnabled(false);
Index: code/branches/objecthierarchy/src/orxonox/objects/Scene.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Scene.cc	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/objects/Scene.cc	(revision 2019)
@@ -0,0 +1,150 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "Scene.h"
+
+#include <OgreRoot.h>
+#include <OgreSceneManager.h>
+#include <OgreSceneNode.h>
+#include <OgreLight.h>
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    CreateFactory(Scene);
+
+    Scene::Scene(BaseObject* creator) : BaseObject(creator)
+    {
+        RegisterObject(Scene);
+
+        this->setScene(this);
+        this->bShadows_ = false;
+
+        if (Ogre::Root::getSingletonPtr())
+        {
+            this->sceneManager_ = Ogre::Root::getSingleton().createSceneManager(Ogre::ST_GENERIC);
+            this->rootSceneNode_ = this->sceneManager_->getRootSceneNode();
+        }
+        else
+        {
+            this->sceneManager_ = 0;
+            this->rootSceneNode_ = 0;
+        }
+
+        // test test test
+        if (this->sceneManager_)
+        {
+            Ogre::Light* light;
+            light = this->sceneManager_->createLight("Light0");
+            light->setType(Ogre::Light::LT_DIRECTIONAL);
+            light->setDiffuseColour(ColourValue(1.0, 0.9, 0.6, 1.0));
+            light->setSpecularColour(ColourValue(1.0, 0.9, 0.6, 1.0));
+            light->setDirection(1, -0.2, 0.2);
+        }
+        // test test test
+    }
+
+    Scene::~Scene()
+    {
+        if (Ogre::Root::getSingletonPtr())
+        {
+//            this->sceneManager_->destroySceneNode(this->rootSceneNode_->getName()); // TODO: remove getName() for newer versions of Ogre
+            Ogre::Root::getSingleton().destroySceneManager(this->sceneManager_);
+        }
+        else
+        {
+        }
+    }
+
+    void Scene::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(Scene, XMLPort, xmlelement, mode);
+
+        XMLPortParam(Scene, "skybox", setSkybox, getSkybox, xmlelement, mode);
+        XMLPortParam(Scene, "ambientlight", setAmbientLight, getAmbientLight, xmlelement, mode).defaultValues(ColourValue(0.2, 0.2, 0.2, 1));
+        XMLPortParam(Scene, "shadow", setShadow, getShadow, xmlelement, mode).defaultValues(true);
+
+        XMLPortObjectExtended(Scene, BaseObject, "", addObject, getObject, xmlelement, mode, true, false);
+    }
+
+    void Scene::registerVariables()
+    {
+        REGISTERSTRING(this->skybox_,     network::direction::toclient, new network::NetworkCallback<Scene>(this, &Scene::networkcallback_applySkybox));
+        REGISTERDATA(this->ambientLight_, network::direction::toclient, new network::NetworkCallback<Scene>(this, &Scene::networkcallback_applyAmbientLight));
+    }
+
+    void Scene::setSkybox(const std::string& skybox)
+    {
+        if (this->sceneManager_)
+            this->sceneManager_->setSkyBox(true, skybox);
+
+        this->skybox_ = skybox;
+    }
+
+    void Scene::setAmbientLight(const ColourValue& colour)
+    {
+        if (this->sceneManager_)
+            this->sceneManager_->setAmbientLight(colour);
+
+        this->ambientLight_ = colour;
+    }
+
+    void Scene::setShadow(bool bShadow)
+    {
+        if (this->sceneManager_)
+        {
+            if (bShadow)
+                this->sceneManager_->setShadowTechnique(Ogre::SHADOWTYPE_STENCIL_ADDITIVE);
+            else
+                this->sceneManager_->setShadowTechnique(Ogre::SHADOWTYPE_NONE);
+        }
+
+        this->bShadows_ = bShadow;
+    }
+
+    void Scene::addObject(BaseObject* object)
+    {
+        this->objects_.push_back(object);
+        object->setScene(this);
+    }
+
+    BaseObject* Scene::getObject(unsigned int index) const
+    {
+        unsigned int i = 0;
+        for (std::list<BaseObject*>::const_iterator it = this->objects_.begin(); it != this->objects_.end(); ++it)
+        {
+            if (i == index)
+                return (*it);
+            ++i;
+        }
+        return 0;
+    }
+}
Index: code/branches/objecthierarchy/src/orxonox/objects/Scene.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Scene.h	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/objects/Scene.h	(revision 2019)
@@ -0,0 +1,84 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Scene_H__
+#define _Scene_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "network/Synchronisable.h"
+#include "core/BaseObject.h"
+#include "util/Math.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport Scene : public BaseObject, public network::Synchronisable
+    {
+        public:
+            Scene(BaseObject* creator);
+            virtual ~Scene();
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            void registerVariables();
+
+            inline Ogre::SceneManager* getSceneManager() const
+                { return this->sceneManager_; }
+            inline Ogre::SceneNode* getRootSceneNode() const
+                { return this->rootSceneNode_; }
+
+            void setSkybox(const std::string& skybox);
+            inline const std::string& getSkybox() const
+                { return this->skybox_; }
+
+            void setAmbientLight(const ColourValue& colour);
+            inline const ColourValue& getAmbientLight() const
+                { return this->ambientLight_; }
+
+            void setShadow(bool bShadow);
+            inline bool getShadow() const
+                { return this->bShadows_; }
+
+        private:
+            void addObject(BaseObject* object);
+            BaseObject* getObject(unsigned int index) const;
+
+            void networkcallback_applySkybox()
+                { this->setSkybox(this->skybox_); }
+            void networkcallback_applyAmbientLight()
+                { this->setAmbientLight(this->ambientLight_); }
+
+            Ogre::SceneManager*    sceneManager_;
+            Ogre::SceneNode*       rootSceneNode_;
+            std::string            skybox_;
+            ColourValue            ambientLight_;
+            std::list<BaseObject*> objects_;
+            bool                   bShadows_;
+    };
+}
+
+#endif /* _Scene_H__ */
Index: code/branches/objecthierarchy/src/orxonox/objects/Script.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Script.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/Script.cc	(revision 2019)
@@ -39,5 +39,5 @@
   CreateFactory(Script);
 
-  Script::Script()
+  Script::Script(BaseObject* creator) : BaseObject(creator)
   {
     RegisterObject(Script);
Index: code/branches/objecthierarchy/src/orxonox/objects/Script.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Script.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/Script.h	(revision 2019)
@@ -39,5 +39,5 @@
   {
     public:
-      Script();
+      Script(BaseObject* creator);
       ~Script();
       void XMLPort(Element& xmlelement, XMLPort::Mode mode);
Index: code/branches/objecthierarchy/src/orxonox/objects/Test.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Test.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/Test.cc	(revision 2019)
@@ -36,5 +36,5 @@
 	CreateFactory ( Test );
 
-	Test::Test()
+	Test::Test(BaseObject* creator) : BaseObject(creator)
 	{
 		RegisterObject ( Test );
